diff -pruN 22.0.2+9-1/debian/changelog 22.0.2+9-1ubuntu1/debian/changelog
--- 22.0.2+9-1/debian/changelog	2024-07-17 09:51:14.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/changelog	2024-07-18 02:41:05.000000000 +0000
@@ -1,3 +1,27 @@
+openjdk-22 (22.0.2+9-1ubuntu1) oracular; urgency=medium
+
+  * OpenJDK 22.0.2, Build 9.
+    - CVEs:
+      + CVE-2024-21147
+      + CVE-2024-21145
+      + CVE-2024-21140
+      + CVE-2024-21131
+      + CVE-2024-21138
+    - Security Fixes:
+      + JDK-8316138: Added GlobalSign R46 and E46 Root CA Certificates.
+      + JDK-8326891: Native Executables and Libraries on Linux Use RPATH Instead
+        of RUNPATH.
+      + JDK-8328638: Fallback Option For POST-only OCSP Requests.
+  * d/copyright: regenerate copyright.
+  * d/watch: use fixed googletest version.
+  * d/rules, d/t/*: collate all excluded tests into d/problemlist.csv.
+  * d/rules: enable fallback linker for Foreign Function and Memory API
+    on i386 and armhf.
+  * d/p/jdk-8336529-proposed.patch: fix time_t migration issue on armhf
+    openjdk is unable to set file last modified timestamp.
+
+ -- Vladimir Petko <vladimir.petko@canonical.com>  Thu, 18 Jul 2024 14:41:05 +1200
+
 openjdk-22 (22.0.2+9-1) unstable; urgency=medium
 
   * OpenJDK 22.0.2, Build 9.
diff -pruN 22.0.2+9-1/debian/control 22.0.2+9-1ubuntu1/debian/control
--- 22.0.2+9-1/debian/control	2024-07-17 09:51:14.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/control	2024-07-18 02:41:05.000000000 +0000
@@ -1,7 +1,8 @@
 Source: openjdk-22
 Section: java
 Priority: optional
-Maintainer: OpenJDK Team <openjdk-22@packages.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: OpenJDK Team <openjdk-22@packages.debian.org>
 Uploaders: Matthias Klose <doko@ubuntu.com>
 Build-Depends: debhelper (>= 11),
   m4, lsb-release, zip, unzip,
diff -pruN 22.0.2+9-1/debian/control.in 22.0.2+9-1ubuntu1/debian/control.in
--- 22.0.2+9-1/debian/control.in	2024-03-20 20:40:42.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/control.in	2024-07-18 02:41:05.000000000 +0000
@@ -1,7 +1,8 @@
 Source: @basename@
 Section: java
 Priority: optional
-Maintainer: OpenJDK Team <@basename@@packages.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: OpenJDK Team <@basename@@packages.debian.org>
 Uploaders: Matthias Klose <doko@ubuntu.com>
 Build-Depends: @bd_debhelper@
   m4, lsb-release, zip, unzip,
diff -pruN 22.0.2+9-1/debian/copyright 22.0.2+9-1ubuntu1/debian/copyright
--- 22.0.2+9-1/debian/copyright	2024-03-20 20:40:42.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/copyright	2024-07-18 02:41:05.000000000 +0000
@@ -423,6 +423,163 @@ License:   GPL with Classpath exception
   directories of modules under src/
   ------------------------------------------------------------------------------
   .
+  %% This notice is provided with respect to SipHash v1.0-68c8a7c,
+  which may be included with JRE 22, JDK 22 and OpenJDK 22
+  .
+  --- begin of LICENSE ---
+  .
+  Notice
+  SipHash reference C implementation
+  .
+  .
+     Copyright (c) 2012-2021 Jean-Philippe Aumasson
+     <jeanphilippe.aumasson@gmail.com>
+     Copyright (c) 2012-2014 Daniel J. Bernstein <djb@cr.yp.to>
+     To the extent possible under law, the author(s) have dedicated all copyright
+     and related and neighboring rights to this software to the public domain
+     worldwide. This software is distributed without any warranty.
+     You should have received a copy of the CC0 Public Domain Dedication along
+     with
+     this software. If not, see
+     <http://creativecommons.org/publicdomain/zero/1.0/>.
+  .
+  .
+  Licenses
+  The code is dual-licensed CCO and MIT
+  .
+  #MIT License
+  .
+  Copyright 2012-2024 JP Aumasson
+  .
+  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
+  .
+  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
+  .
+  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+  .
+  .
+  #CC0 1.0 Universal
+  .
+  Statement of Purpose
+  .
+  The laws of most jurisdictions throughout the world automatically confer
+  exclusive Copyright and Related Rights (defined below) upon the creator and
+  subsequent owner(s) (each and all, an "owner") of an original work of
+  authorship and/or a database (each, a "Work").
+  .
+  Certain owners wish to permanently relinquish those rights to a Work for the
+  purpose of contributing to a commons of creative, cultural and scientific
+  works ("Commons") that the public can reliably and without fear of later
+  claims of infringement build upon, modify, incorporate in other works, reuse
+  and redistribute as freely as possible in any form whatsoever and for any
+  purposes, including without limitation commercial purposes. These owners may
+  contribute to the Commons to promote the ideal of a free culture and the
+  further production of creative, cultural and scientific works, or to gain
+  reputation or greater distribution for their Work in part through the use and
+  efforts of others.
+  .
+  For these and/or other purposes and motivations, and without any expectation
+  of additional consideration or compensation, the person associating CC0 with a
+  Work (the "Affirmer"), to the extent that he or she is an owner of Copyright
+  and Related Rights in the Work, voluntarily elects to apply CC0 to the Work
+  and publicly distribute the Work under its terms, with knowledge of his or her
+  Copyright and Related Rights in the Work and the meaning and intended legal
+  effect of CC0 on those rights.
+  .
+  1. Copyright and Related Rights. A Work made available under CC0 may be
+  protected by copyright and related or neighboring rights ("Copyright and
+  Related Rights"). Copyright and Related Rights include, but are not limited
+  to, the following:
+  .
+    i. the right to reproduce, adapt, distribute, perform, display, communicate,
+    and translate a Work;
+  .
+    ii. moral rights retained by the original author(s) and/or performer(s);
+  .
+    iii. publicity and privacy rights pertaining to a person's image or likeness
+    depicted in a Work;
+  .
+    iv. rights protecting against unfair competition in regards to a Work,
+    subject to the limitations in paragraph 4(a), below;
+  .
+    v. rights protecting the extraction, dissemination, use and reuse of data in
+    a Work;
+  .
+    vi. database rights (such as those arising under Directive 96/9/EC of the
+    European Parliament and of the Council of 11 March 1996 on the legal
+    protection of databases, and under any national implementation thereof,
+    including any amended or successor version of such directive); and
+  .
+    vii. other similar, equivalent or corresponding rights throughout the world
+    based on applicable law or treaty, and any national implementations thereof.
+  .
+  2. Waiver. To the greatest extent permitted by, but not in contravention of,
+  applicable law, Affirmer hereby overtly, fully, permanently, irrevocably and
+  unconditionally waives, abandons, and surrenders all of Affirmer's Copyright
+  and Related Rights and associated claims and causes of action, whether now
+  known or unknown (including existing as well as future claims and causes of
+  action), in the Work (i) in all territories worldwide, (ii) for the maximum
+  duration provided by applicable law or treaty (including future time
+  extensions), (iii) in any current or future medium and for any number of
+  copies, and (iv) for any purpose whatsoever, including without limitation
+  commercial, advertising or promotional purposes (the "Waiver"). Affirmer makes
+  the Waiver for the benefit of each member of the public at large and to the
+  detriment of Affirmer's heirs and successors, fully intending that such Waiver
+  shall not be subject to revocation, rescission, cancellation, termination, or
+  any other legal or equitable action to disrupt the quiet enjoyment of the Work
+  by the public as contemplated by Affirmer's express Statement of Purpose.
+  .
+  3. Public License Fallback. Should any part of the Waiver for any reason be
+  judged legally invalid or ineffective under applicable law, then the Waiver
+  shall be preserved to the maximum extent permitted taking into account
+  Affirmer's express Statement of Purpose. In addition, to the extent the Waiver
+  is so judged Affirmer hereby grants to each affected person a royalty-free,
+  non transferable, non sublicensable, non exclusive, irrevocable and
+  unconditional license to exercise Affirmer's Copyright and Related Rights in
+  the Work (i) in all territories worldwide, (ii) for the maximum duration
+  provided by applicable law or treaty (including future time extensions), (iii)
+  in any current or future medium and for any number of copies, and (iv) for any
+  purpose whatsoever, including without limitation commercial, advertising or
+  promotional purposes (the "License"). The License shall be deemed effective as
+  of the date CC0 was applied by Affirmer to the Work. Should any part of the
+  License for any reason be judged legally invalid or ineffective under
+  applicable law, such partial invalidity or ineffectiveness shall not
+  invalidate the remainder of the License, and in such case Affirmer hereby
+  affirms that he or she will not (i) exercise any of his or her remaining
+  Copyright and Related Rights in the Work or (ii) assert any associated claims
+  and causes of action with respect to the Work, in either case contrary to
+  Affirmer's express Statement of Purpose.
+  .
+  4. Limitations and Disclaimers.
+  .
+    a. No trademark or patent rights held by Affirmer are waived, abandoned,
+    surrendered, licensed or otherwise affected by this document.
+  .
+    b. Affirmer offers the Work as-is and makes no representations or warranties
+    of any kind concerning the Work, express, implied, statutory or otherwise,
+    including without limitation warranties of title, merchantability, fitness
+    for a particular purpose, non infringement, or the absence of latent or
+    other defects, accuracy, or the present or absence of errors, whether or not
+    discoverable, all to the greatest extent permissible under applicable law.
+  .
+    c. Affirmer disclaims responsibility for clearing rights of other persons
+    that may apply to the Work or any use thereof, including without limitation
+    any person's Copyright and Related Rights in the Work. Further, Affirmer
+    disclaims responsibility for obtaining any necessary consents, permissions
+    or other rights required for any use of the Work.
+  .
+    d. Affirmer understands and acknowledges that Creative Commons is not a
+    party to this document and has no duty or obligation with respect to this
+    CC0 or use of the Work.
+  .
+  For more information, please see
+  <http://creativecommons.org/publicdomain/zero/1.0/>
+  .
+  .
+  .
+  --- end of LICENSE ---
+  .
+  ------------------------------------------------------------------------------
   %% This notice is provided with respect to Cryptix AES v3.2.0,
   which may be included with JRE 22, JDK 22 and OpenJDK 22
   .
@@ -1190,6 +1347,163 @@ License:   GPL with Classpath exception
   --- end of LICENSE ---
   .
   ------------------------------------------------------------------------------
+  %% This notice is provided with respect to SipHash v1.0-68c8a7c,
+  which may be included with JRE 22, JDK 22 and OpenJDK 22
+  .
+  --- begin of LICENSE ---
+  .
+  Notice
+  SipHash reference C implementation
+  .
+  .
+     Copyright (c) 2016 Jean-Philippe Aumasson <jeanphilippe.aumasson@gmail.com>
+  .
+     To the extent possible under law, the author(s) have dedicated all copyright
+     and related and neighboring rights to this software to the public domain
+     worldwide. This software is distributed without any warranty.
+  .
+     You should have received a copy of the CC0 Public Domain Dedication along
+     with
+     this software. If not, see
+     <http://creativecommons.org/publicdomain/zero/1.0/>.
+  .
+  .
+  Licenses
+  The code is dual-licensed CCO and MIT
+  .
+  #MIT License
+  .
+  Copyright 2012-2024 JP Aumasson
+  .
+  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
+  .
+  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
+  .
+  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+  .
+  .
+  #CC0 1.0 Universal
+  .
+  Statement of Purpose
+  .
+  The laws of most jurisdictions throughout the world automatically confer
+  exclusive Copyright and Related Rights (defined below) upon the creator and
+  subsequent owner(s) (each and all, an "owner") of an original work of
+  authorship and/or a database (each, a "Work").
+  .
+  Certain owners wish to permanently relinquish those rights to a Work for the
+  purpose of contributing to a commons of creative, cultural and scientific
+  works ("Commons") that the public can reliably and without fear of later
+  claims of infringement build upon, modify, incorporate in other works, reuse
+  and redistribute as freely as possible in any form whatsoever and for any
+  purposes, including without limitation commercial purposes. These owners may
+  contribute to the Commons to promote the ideal of a free culture and the
+  further production of creative, cultural and scientific works, or to gain
+  reputation or greater distribution for their Work in part through the use and
+  efforts of others.
+  .
+  For these and/or other purposes and motivations, and without any expectation
+  of additional consideration or compensation, the person associating CC0 with a
+  Work (the "Affirmer"), to the extent that he or she is an owner of Copyright
+  and Related Rights in the Work, voluntarily elects to apply CC0 to the Work
+  and publicly distribute the Work under its terms, with knowledge of his or her
+  Copyright and Related Rights in the Work and the meaning and intended legal
+  effect of CC0 on those rights.
+  .
+  1. Copyright and Related Rights. A Work made available under CC0 may be
+  protected by copyright and related or neighboring rights ("Copyright and
+  Related Rights"). Copyright and Related Rights include, but are not limited
+  to, the following:
+  .
+    i. the right to reproduce, adapt, distribute, perform, display, communicate,
+    and translate a Work;
+  .
+    ii. moral rights retained by the original author(s) and/or performer(s);
+  .
+    iii. publicity and privacy rights pertaining to a person's image or likeness
+    depicted in a Work;
+  .
+    iv. rights protecting against unfair competition in regards to a Work,
+    subject to the limitations in paragraph 4(a), below;
+  .
+    v. rights protecting the extraction, dissemination, use and reuse of data in
+    a Work;
+  .
+    vi. database rights (such as those arising under Directive 96/9/EC of the
+    European Parliament and of the Council of 11 March 1996 on the legal
+    protection of databases, and under any national implementation thereof,
+    including any amended or successor version of such directive); and
+  .
+    vii. other similar, equivalent or corresponding rights throughout the world
+    based on applicable law or treaty, and any national implementations thereof.
+  .
+  2. Waiver. To the greatest extent permitted by, but not in contravention of,
+  applicable law, Affirmer hereby overtly, fully, permanently, irrevocably and
+  unconditionally waives, abandons, and surrenders all of Affirmer's Copyright
+  and Related Rights and associated claims and causes of action, whether now
+  known or unknown (including existing as well as future claims and causes of
+  action), in the Work (i) in all territories worldwide, (ii) for the maximum
+  duration provided by applicable law or treaty (including future time
+  extensions), (iii) in any current or future medium and for any number of
+  copies, and (iv) for any purpose whatsoever, including without limitation
+  commercial, advertising or promotional purposes (the "Waiver"). Affirmer makes
+  the Waiver for the benefit of each member of the public at large and to the
+  detriment of Affirmer's heirs and successors, fully intending that such Waiver
+  shall not be subject to revocation, rescission, cancellation, termination, or
+  any other legal or equitable action to disrupt the quiet enjoyment of the Work
+  by the public as contemplated by Affirmer's express Statement of Purpose.
+  .
+  3. Public License Fallback. Should any part of the Waiver for any reason be
+  judged legally invalid or ineffective under applicable law, then the Waiver
+  shall be preserved to the maximum extent permitted taking into account
+  Affirmer's express Statement of Purpose. In addition, to the extent the Waiver
+  is so judged Affirmer hereby grants to each affected person a royalty-free,
+  non transferable, non sublicensable, non exclusive, irrevocable and
+  unconditional license to exercise Affirmer's Copyright and Related Rights in
+  the Work (i) in all territories worldwide, (ii) for the maximum duration
+  provided by applicable law or treaty (including future time extensions), (iii)
+  in any current or future medium and for any number of copies, and (iv) for any
+  purpose whatsoever, including without limitation commercial, advertising or
+  promotional purposes (the "License"). The License shall be deemed effective as
+  of the date CC0 was applied by Affirmer to the Work. Should any part of the
+  License for any reason be judged legally invalid or ineffective under
+  applicable law, such partial invalidity or ineffectiveness shall not
+  invalidate the remainder of the License, and in such case Affirmer hereby
+  affirms that he or she will not (i) exercise any of his or her remaining
+  Copyright and Related Rights in the Work or (ii) assert any associated claims
+  and causes of action with respect to the Work, in either case contrary to
+  Affirmer's express Statement of Purpose.
+  .
+  4. Limitations and Disclaimers.
+  .
+    a. No trademark or patent rights held by Affirmer are waived, abandoned,
+    surrendered, licensed or otherwise affected by this document.
+  .
+    b. Affirmer offers the Work as-is and makes no representations or warranties
+    of any kind concerning the Work, express, implied, statutory or otherwise,
+    including without limitation warranties of title, merchantability, fitness
+    for a particular purpose, non infringement, or the absence of latent or
+    other defects, accuracy, or the present or absence of errors, whether or not
+    discoverable, all to the greatest extent permissible under applicable law.
+  .
+    c. Affirmer disclaims responsibility for clearing rights of other persons
+    that may apply to the Work or any use thereof, including without limitation
+    any person's Copyright and Related Rights in the Work. Further, Affirmer
+    disclaims responsibility for obtaining any necessary consents, permissions
+    or other rights required for any use of the Work.
+  .
+    d. Affirmer understands and acknowledges that Creative Commons is not a
+    party to this document and has no duty or obligation with respect to this
+    CC0 or use of the Work.
+  .
+  For more information, please see
+  <http://creativecommons.org/publicdomain/zero/1.0/>
+  .
+  .
+  .
+  --- end of LICENSE ---
+  .
+  ------------------------------------------------------------------------------
   %% This notice is provided with respect to The Unicode Standard, Unicode Character Database, Version 15.1.0,
   which may be included with JRE 22, JDK 22 and OpenJDK 22
   .
@@ -1530,7 +1844,7 @@ License:   GPL with Classpath exception
   .
   .
   GPL v2: Refer to the copy under /usr/share/common-licenses
-  : Refer to the copy under /usr/share/common-licenses
+  .
   Additional Freetype Attributions
   .
   .
@@ -1737,40 +2051,35 @@ License:   GPL with Classpath exception
   --- end of LICENSE ---
   .
   ------------------------------------------------------------------------------
-  %% This notice is provided with respect to Little Color Management System (LCMS) v2.15,
+  %% This notice is provided with respect to Little Color Management System (LCMS) v2.16,
   which may be included with JRE 22, JDK 22 and OpenJDK 22
   .
   --- begin of LICENSE ---
   .
   LCMS License
   .
-  README.1ST file information
-  .
-  LittleCMS core is released under MIT License
   .
-  ---------------------------------
+  MIT License
   .
-  Little CMS
-  Copyright (c) 1998-2023 Marti Maria Saguer
+  Copyright (C) 1998-2023 Marti Maria Saguer
   .
   Permission is hereby granted, free of charge, to any person obtaining
-  a copy of this software and associated documentation files (the
-  "Software"), to deal in the Software without restriction, including
-  without limitation the rights to use, copy, modify, merge, publish,
-  distribute, sublicense, and/or sell copies of the Software, and to
-  permit persons to whom the Software is furnished to do so, subject
-  to the following conditions:
+  a copy of this software and associated documentation files (the "Software"),
+  to deal in the Software without restriction, including without limitation
+  the rights to use, copy, modify, merge, publish, distribute, sublicense,
+  and/or sell copies of the Software, and to permit persons to whom the Software
+  is furnished to do so, subject to the following conditions:
   .
-  The above copyright notice and this permission notice shall be
-  included in all copies or substantial portions of the Software.
+  The above copyright notice and this permission notice shall be included in
+  all copies or substantial portions of the Software.
   .
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
-  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
-  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
-  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
-  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
-  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO
+  THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
+  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+  OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
   .
   ---------------------------------
   The below license applies to the following files:
@@ -1789,7 +2098,6 @@ License:   GPL with Classpath exception
   AUTHORS File Information
   .
   .
-  .
   Main Author
   ------------
   Marti Maria
@@ -1833,6 +2141,7 @@ License:   GPL with Classpath exception
   Amyspark
   Lovell Fuller
   Eli Schwartz
+  Diogo Teles Sant'Anna
   .
   Special Thanks
   --------------
@@ -2099,7 +2408,7 @@ License:   GPL with Classpath exception
   .
   .
   Apache 2.0 License: Refer to the copy under /usr/share/common-licenses
-  : Refer to the copy under /usr/share/common-licenses
+  .
   .
   --- end of LICENSE ---
   .
@@ -2258,7 +2567,7 @@ License:   GPL with Classpath exception
   .
   .
   Apache 2.0 License: Refer to the copy under /usr/share/common-licenses
-  : Refer to the copy under /usr/share/common-licenses
+  .
   .
   --- end of LICENSE ---
   .
@@ -2290,7 +2599,7 @@ License:   GPL with Classpath exception
   .
   .
   Apache 2.0 License: Refer to the copy under /usr/share/common-licenses
-  : Refer to the copy under /usr/share/common-licenses
+  .
   .
   --- end of LICENSE ---
   .
@@ -2301,7 +2610,7 @@ License:   GPL with Classpath exception
   --- begin of LICENSE ---
   .
   Apache 2.0 License: Refer to the copy under /usr/share/common-licenses
-  : Refer to the copy under /usr/share/common-licenses
+  .
   Apache Santuario Notice
   .
   .
diff -pruN 22.0.2+9-1/debian/patches/exclude-broken-tests.patch 22.0.2+9-1ubuntu1/debian/patches/exclude-broken-tests.patch
--- 22.0.2+9-1/debian/patches/exclude-broken-tests.patch	2023-09-04 08:27:28.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/patches/exclude-broken-tests.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,85 +0,0 @@
- Description: Disable failing tests
- Disable tests that fail on Ubuntu pending investigation
-Author: Vladimir Petko <vladimir.petko@canonical.com>
-Forwarded: not-needed
-Last-Update: 2023-03-24
---- a/test/hotspot/jtreg/ProblemList.txt
-+++ b/test/hotspot/jtreg/ProblemList.txt
-@@ -38,6 +38,15 @@
- #
- #############################################################################
- 
-+# tests that need to be investigated
-+
-+gc/shenandoah/mxbeans/TestChurnNotifications.java#aggressive 0000000 generic-all
-+gc/shenandoah/mxbeans/TestChurnNotifications.java#iu 0000000 generic-all
-+
-+#result: Failed. Execution failed: `main' threw exception: java.io.IOException: Mount point not found
-+# https://bugs.openjdk.org/browse/JDK-8166162
-+
-+runtime/LoadClass/LongBCP.java 8166162 generic-all
- 
- #############################################################################
- 
---- a/test/jdk/ProblemList.txt
-+++ b/test/jdk/ProblemList.txt
-@@ -109,6 +109,51 @@
- #
- #############################################################################
- 
-+# NSS3 failure when processing SHA3 hashes (needs investigation)
-+sun/security/pkcs11/Signature/KeyAndParamCheckForPSS.java 0000000 generic-all
-+sun/security/pkcs11/MessageDigest/TestCloning.java 0000000 generic-all
-+sun/security/pkcs11/Signature/SignatureTestPSS.java 0000000 generic-all
-+
-+# to investigate
-+# unable to read LD_LIBRARY_PATH env variable
-+
-+tools/jpackage/share/AppLauncherEnvTest.java 0000000 generic-all
-+
-+# java.lang.Exception: Proc abnormal end
-+
-+sun/security/krb5/auto/Cleaners.java 0000000 generic-all
-+
-+# result: Failed. Execution failed: `main' threw exception: java.io.IOException: Mount point not found
-+# https://bugs.openjdk.org/browse/JDK-8166162
-+
-+java/io/File/createTempFile/TargetDirectory.java 8166162 generic-all
-+java/nio/file/Files/CheckPermissions.java 8166162 generic-all
-+java/nio/file/Files/TemporaryFiles.java 8166162 generic-all
-+java/nio/file/Files/Misc.java 8166162 generic-all
-+java/nio/file/Files/CopyAndMove.java 8166162 generic-all
-+java/nio/file/Files/InterruptCopy.java 8166162 generic-all
-+java/nio/file/Files/FileAttributes.java 8166162 generic-all
-+java/nio/file/attribute/BasicFileAttributeView/SetTimesNanos.java 8166162 generic-all
-+java/nio/file/attribute/AclFileAttributeView/Basic.java 8166162 generic-all
-+java/nio/file/attribute/DosFileAttributeView/Basic.java 8166162 generic-all
-+java/nio/file/attribute/PosixFileAttributeView/Basic.java 8166162 generic-all
-+java/nio/file/attribute/UserDefinedFileAttributeView/Basic.java 8166162 generic-all
-+java/nio/file/FileStore/Basic.java 8166162 generic-all
-+java/nio/channels/FileChannel/directio/DirectIOTest.java 8166162 generic-all
-+java/nio/channels/FileChannel/directio/ReadDirect.java 8166162 generic-all
-+java/nio/channels/FileChannel/directio/PreadDirect.java 8166162 generic-all
-+java/nio/channels/FileChannel/directio/PwriteDirect.java 8166162 generic-all
-+java/nio/channels/FileChannel/directio/WriteDirect.java 8166162 generic-all
-+
-+# utf-8 locale is missing on build machine
-+# https://bugs.openjdk.org/browse/JDK-8249079
-+
-+java/lang/invoke/lambda/LambdaFileEncodingSerialization.java 8249079 generic-all
-+
-+# disable scoped value (incubating feature) test pending investigation
-+
-+jdk/incubator/concurrent/ScopedValue/StressStackOverflow.java 000000 generic-all
-+
- ############################################################################
- 
- # jdk_awt
-@@ -476,7 +521,6 @@ java/beans/XMLEncoder/Test6570354.java 8
- java/lang/ProcessHandle/InfoTest.java                           8211847 aix-ppc64
- java/lang/invoke/LFCaching/LFMultiThreadCachingTest.java        8151492 generic-all
- java/lang/invoke/LFCaching/LFGarbageCollectedTest.java          8078602 generic-all
--java/lang/invoke/lambda/LambdaFileEncodingSerialization.java    8249079 linux-x64
- java/lang/invoke/RicochetTest.java                              8251969 generic-all
- 
- ############################################################################
diff -pruN 22.0.2+9-1/debian/patches/jdk-8336529-proposed.patch 22.0.2+9-1ubuntu1/debian/patches/jdk-8336529-proposed.patch
--- 22.0.2+9-1/debian/patches/jdk-8336529-proposed.patch	1970-01-01 00:00:00.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/patches/jdk-8336529-proposed.patch	2024-07-18 02:41:05.000000000 +0000
@@ -0,0 +1,55 @@
+Description: (fs) UnixFileAttributeViews setTimes() failing on armhf, Ubuntu noble
+ time_t transition in Debian/Ubuntu left 32 bit time_t symbols in glibc.
+ Looking up 'futimens' via dlsym returns 32 bit version of the function.
+ This is causing failure to set last modified time
+ (e.g. instead of year 2017 we get 1976 in the test).
+ Using the function directly correctly calls 64 bit versions.
+ When we lookup functions with time_t arguments through dlsym()
+ calls we should use 64 bit versions.
+Author: Vladimir Petko <vladimir.petko@canonical.com>
+Origin: upstream, https://github.com/openjdk/jdk/pull/20208
+Bug: https://bugs.openjdk.org/browse/JDK-8336529
+Bug-Ubuntu: https://bugs.launchpad.net/ubuntu/+source/openjdk-23/+bug/2073335
+Last-Update: 2024-07-17
+---
+
+--- a/src/java.base/unix/native/libnio/fs/UnixNativeDispatcher.c
++++ b/src/java.base/unix/native/libnio/fs/UnixNativeDispatcher.c
+@@ -280,6 +280,20 @@
+ }
+ #endif
+ 
++/**
++ * Lookup time functions symbols, trying 64 bit version first
++ */
++static void* lookup_time_function(const char* symbol64, const char* symbol) {
++    void* ret = NULL;
++    if (sizeof(time_t) > 4) {
++        ret = dlsym(RTLD_DEFAULT, symbol64);
++    }
++    if (ret == NULL) {
++        ret = dlsym(RTLD_DEFAULT, symbol);
++    }
++    return ret;
++}
++
+ #if defined(__linux__)
+ static int statx_wrapper(int dirfd, const char *restrict pathname, int flags,
+                          unsigned int mask, struct my_statx *restrict statxbuf) {
+@@ -384,10 +398,13 @@
+     my_unlinkat_func = (unlinkat_func*) dlsym(RTLD_DEFAULT, "unlinkat");
+     my_renameat_func = (renameat_func*) dlsym(RTLD_DEFAULT, "renameat");
+ #ifndef _ALLBSD_SOURCE
+-    my_futimesat_func = (futimesat_func*) dlsym(RTLD_DEFAULT, "futimesat");
+-    my_lutimes_func = (lutimes_func*) dlsym(RTLD_DEFAULT, "lutimes");
++    my_futimesat_func = (futimesat_func*) lookup_time_function("__futimesat64",
++        "futimesat");
++    my_lutimes_func = (lutimes_func*) lookup_time_function("__lutimes64",
++        "lutimes");
+ #endif
+-    my_futimens_func = (futimens_func*) dlsym(RTLD_DEFAULT, "futimens");
++    my_futimens_func = (futimens_func*) lookup_time_function("__futimens64",
++        "futimens");
+ #if defined(_AIX)
+     my_fdopendir_func = (fdopendir_func*) dlsym(RTLD_DEFAULT, "fdopendir64");
+ #else
diff -pruN 22.0.2+9-1/debian/patches/series 22.0.2+9-1ubuntu1/debian/patches/series
--- 22.0.2+9-1/debian/patches/series	2024-07-17 09:51:14.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/patches/series	2024-07-18 02:41:05.000000000 +0000
@@ -38,3 +38,4 @@ warn-fontmanager.patch
 hsdis-fpic.patch
 jdk-8329983.patch
 jdk-8331541.patch
+jdk-8336529-proposed.patch
diff -pruN 22.0.2+9-1/debian/rules 22.0.2+9-1ubuntu1/debian/rules
--- 22.0.2+9-1/debian/rules	2024-07-17 09:51:14.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/rules	2024-07-18 02:41:05.000000000 +0000
@@ -419,6 +419,10 @@ ifneq (,$(filter $(DEB_HOST_ARCH),$(hots
   DEFAULT_CONFIGURE_ARGS += --disable-precompiled-headers
 endif
 
+ifneq (,$(filter $(DEB_HOST_ARCH), armhf i386))
+  DEFAULT_CONFIGURE_ARGS += --enable-fallback-linker
+endif
+
 ifneq (,$(filter $(DEB_HOST_ARCH), powerpc))
   DEFAULT_CONFIGURE_ARGS += --with-boot-jdk-jvmargs="-XX:ThreadStackSize=2240"
 endif
@@ -967,7 +971,8 @@ gen-autopkgtests: debian/tests/jtdiff-au
 	debian/tests/jtreg-autopkgtest.sh \
 	debian/tests/jdk-autopkgtest.sh \
 	debian/tests/hotspot-autopkgtest.sh \
-	debian/tests/dependencies.sh
+	debian/tests/dependencies.sh \
+	debian/tests/write-problems.sh
 
 packaging-files:
 	for f in debian/*.in; do \
diff -pruN 22.0.2+9-1/debian/tests/hotspot 22.0.2+9-1ubuntu1/debian/tests/hotspot
--- 22.0.2+9-1/debian/tests/hotspot	2023-10-20 08:16:38.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/hotspot	2024-07-18 02:41:05.000000000 +0000
@@ -5,7 +5,7 @@ set -o pipefail
 set -o nounset
 
 problem_list=${AUTOPKGTEST_TMP}/problems.txt
-debian/tests/write-problems ${problem_list} test/hotspot/jtreg/ProblemList.txt hotspot
+debian/tests/write-problems.sh ${problem_list} test/hotspot/jtreg/ProblemList.txt hotspot
 
 native_path=$(pwd)/build/images/test/hotspot/jtreg/native
 debian/tests/jtreg-autopkgtest.sh hotspot \
diff -pruN 22.0.2+9-1/debian/tests/hotspot-autopkgtest.in 22.0.2+9-1ubuntu1/debian/tests/hotspot-autopkgtest.in
--- 22.0.2+9-1/debian/tests/hotspot-autopkgtest.in	2024-03-20 20:40:42.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/hotspot-autopkgtest.in	2024-07-18 02:41:05.000000000 +0000
@@ -21,7 +21,7 @@ HOTSPOT_JTREG_PATH=test/hotspot/jtreg
 HOTSPOT_JTREG_NATIVE_PATH=${jdk_path}/testsuite/hotspot/jtreg/native
 
 problem_list=${AUTOPKGTEST_TMP}/problems.txt
-debian/tests/write-problems ${problem_list} ${HOTSPOT_JTREG_PATH}/ProblemList.txt hotspot
+debian/tests/write-problems.sh ${problem_list} ${HOTSPOT_JTREG_PATH}/ProblemList.txt hotspot
 
 ARGS="$*"
 JT_DEFAULT_ARGS="-exclude:${problem_list} -k:!stress :tier1"
diff -pruN 22.0.2+9-1/debian/tests/hotspot-autopkgtest.sh 22.0.2+9-1ubuntu1/debian/tests/hotspot-autopkgtest.sh
--- 22.0.2+9-1/debian/tests/hotspot-autopkgtest.sh	2024-06-29 08:03:47.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/hotspot-autopkgtest.sh	2024-07-18 02:41:05.000000000 +0000
@@ -21,7 +21,7 @@ HOTSPOT_JTREG_PATH=test/hotspot/jtreg
 HOTSPOT_JTREG_NATIVE_PATH=${jdk_path}/testsuite/hotspot/jtreg/native
 
 problem_list=${AUTOPKGTEST_TMP}/problems.txt
-debian/tests/write-problems ${problem_list} ${HOTSPOT_JTREG_PATH}/ProblemList.txt hotspot
+debian/tests/write-problems.sh ${problem_list} ${HOTSPOT_JTREG_PATH}/ProblemList.txt hotspot
 
 ARGS="$*"
 JT_DEFAULT_ARGS="-exclude:${problem_list} -k:!stress :tier1"
diff -pruN 22.0.2+9-1/debian/tests/jaxp 22.0.2+9-1ubuntu1/debian/tests/jaxp
--- 22.0.2+9-1/debian/tests/jaxp	2023-10-20 08:16:38.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/jaxp	2024-07-18 02:41:05.000000000 +0000
@@ -6,7 +6,7 @@ set -o nounset
 
 
 problem_list=${AUTOPKGTEST_TMP}/problems.txt
-debian/tests/write-problems ${problem_list} test/jaxp/ProblemList.txt jaxp
+debian/tests/write-problems.sh ${problem_list} test/jaxp/ProblemList.txt jaxp
 
 debian/tests/jtreg-autopkgtest.sh jaxp \
     -exclude:${problem_list} \
diff -pruN 22.0.2+9-1/debian/tests/jdk 22.0.2+9-1ubuntu1/debian/tests/jdk
--- 22.0.2+9-1/debian/tests/jdk	2023-10-20 08:16:38.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/jdk	2024-07-18 02:41:05.000000000 +0000
@@ -27,7 +27,7 @@ sleep 3
 
 
 problem_list=${AUTOPKGTEST_TMP}/problems.txt
-debian/tests/write-problems ${problem_list} test/jdk/ProblemList.txt jdk
+debian/tests/write-problems.sh ${problem_list} test/jdk/ProblemList.txt jdk
 
 native_path=$(pwd)/build/images/test/jdk/jtreg/native
 debian/tests/jtreg-autopkgtest.sh jdk \
diff -pruN 22.0.2+9-1/debian/tests/jdk-autopkgtest.in 22.0.2+9-1ubuntu1/debian/tests/jdk-autopkgtest.in
--- 22.0.2+9-1/debian/tests/jdk-autopkgtest.in	2024-03-20 20:40:42.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/jdk-autopkgtest.in	2024-07-18 02:41:05.000000000 +0000
@@ -42,7 +42,7 @@ JDK_JTREG_NATIVE_PATH=${jdk_path}/testsu
 
 problem_list=${AUTOPKGTEST_TMP}/problems.txt
 
-debian/tests/write-problems ${problem_list} ${JDK_JTREG_PATH}/ProblemList.txt jdk
+debian/tests/write-problems.sh ${problem_list} ${JDK_JTREG_PATH}/ProblemList.txt jdk
 
 ARGS="$*"
 JT_DEFAULT_ARGS="-exclude:${problem_list} -k:!stress :tier1"
diff -pruN 22.0.2+9-1/debian/tests/jdk-autopkgtest.sh 22.0.2+9-1ubuntu1/debian/tests/jdk-autopkgtest.sh
--- 22.0.2+9-1/debian/tests/jdk-autopkgtest.sh	2024-06-29 08:03:47.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/jdk-autopkgtest.sh	2024-07-18 02:41:05.000000000 +0000
@@ -42,7 +42,7 @@ JDK_JTREG_NATIVE_PATH=${jdk_path}/testsu
 
 problem_list=${AUTOPKGTEST_TMP}/problems.txt
 
-debian/tests/write-problems ${problem_list} ${JDK_JTREG_PATH}/ProblemList.txt jdk
+debian/tests/write-problems.sh ${problem_list} ${JDK_JTREG_PATH}/ProblemList.txt jdk
 
 ARGS="$*"
 JT_DEFAULT_ARGS="-exclude:${problem_list} -k:!stress :tier1"
diff -pruN 22.0.2+9-1/debian/tests/langtools 22.0.2+9-1ubuntu1/debian/tests/langtools
--- 22.0.2+9-1/debian/tests/langtools	2023-10-20 08:16:38.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/langtools	2024-07-18 02:41:05.000000000 +0000
@@ -5,7 +5,7 @@ set -o pipefail
 set -o nounset
 
 problem_list=${AUTOPKGTEST_TMP}/problems.txt
-debian/tests/write-problems ${problem_list} test/langtools/ProblemList.txt langtools
+debian/tests/write-problems.sh ${problem_list} test/langtools/ProblemList.txt langtools
 
 debian/tests/jtreg-autopkgtest.sh langtools \
   -exclude:${problem_list} \
diff -pruN 22.0.2+9-1/debian/tests/problems-armhf.txt 22.0.2+9-1ubuntu1/debian/tests/problems-armhf.txt
--- 22.0.2+9-1/debian/tests/problems-armhf.txt	2023-10-20 08:16:38.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/problems-armhf.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,35 +0,0 @@
-
-# :hotspot
-
-# exclude test pending investigation
-# see https://launchpadlibrarian.net/658682532/buildlog_ubuntu-lunar-armhf.openjdk-20_20+36~us1-0ubuntu1~ppa22_BUILDING.txt.gz
-# crash log was present.
-
-runtime/ErrorHandling/MachCodeFramesInErrorFile.java 000000 generic-all
-
-# In armhf vm profiled methods code cache memory bean is not present.
-# This causes npe in the test.
-# The patch can not be sent upstream as it requires further investigation,
-
-compiler/codecache/MHIntrinsicAllocFailureTest.java
-
-# : jdk
-
-# this test passes but is very slow in CI, causing timeout
-
-sun/security/rsa/SignedObjectChain.java 000000 generic-all
-sun/security/ec/ed/EdDSATest.java 000000 generic-all
-java/security/SignedObject/Chain.java 000000 generic-all
-
-# timeout in SSL connection
-java/net/httpclient/ManyRequestsLegacy.java 000000 generic-all
-# deadlock
-java/util/Random/RandomTestBsi1999.java 000000 generic-all
-javax/crypto/KEM/GenLargeNumberOfKeys.java 000000 generic-all
-
-# runner issue, disk space size exceeds 32 bit integer
-java/io/File/GetXSpace.java 000000 generic-all
-
-# https://bugs.openjdk.org/browse/JDK-8303168
-serviceability/AsyncGetCallTrace/MyPackage/ASGCTBaseTest.java 000000 generic-all
-
diff -pruN 22.0.2+9-1/debian/tests/problems-hotspot.txt 22.0.2+9-1ubuntu1/debian/tests/problems-hotspot.txt
--- 22.0.2+9-1/debian/tests/problems-hotspot.txt	2023-10-20 08:16:38.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/problems-hotspot.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,13 +0,0 @@
-# tests that need to be investigated
-
-gc/shenandoah/mxbeans/TestChurnNotifications.java#aggressive 0000000 generic-all
-gc/shenandoah/mxbeans/TestChurnNotifications.java#iu 0000000 generic-all
-
-#result: Failed. Execution failed: `main' threw exception: java.io.IOException: Mount point not found
-# https://bugs.openjdk.org/browse/JDK-8166162
-
-runtime/LoadClass/LongBCP.java 8166162 generic-all
-
-# flaky test
-compiler/vectorization/runner/MultipleLoopsTest.java 000000 generic-all
-
diff -pruN 22.0.2+9-1/debian/tests/problems-i386.txt 22.0.2+9-1ubuntu1/debian/tests/problems-i386.txt
--- 22.0.2+9-1/debian/tests/problems-i386.txt	2023-10-20 08:16:38.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/problems-i386.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,17 +0,0 @@
-
-# quarantine i386 tests pending investigation
-
-# : hotspot
-
-compiler/arguments/CheckCICompilerCount.java 000000 generic-all
-gtest/MetaspaceGtests.java#reclaim-none-ndebug 000000 generic-all
-gtest/MetaspaceGtests.java#reclaim-aggressive-ndebug 000000 generic-all
-gtest/GTestWrapper.java 000000 generic-all
-
-# : jdk
-
-tools/jlink/JLinkTest.java 000000 generic-all
-
-# runner issue, disk space size exceeds 32 bit integer
-java/io/File/GetXSpace.java 000000 generic-all
-
diff -pruN 22.0.2+9-1/debian/tests/problems-jdk.txt 22.0.2+9-1ubuntu1/debian/tests/problems-jdk.txt
--- 22.0.2+9-1/debian/tests/problems-jdk.txt	2023-10-20 08:16:38.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/problems-jdk.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,46 +0,0 @@
-# NSS3 failure when processing SHA3 hashes (needs investigation)
-sun/security/pkcs11/Signature/KeyAndParamCheckForPSS.java 0000000 generic-all
-sun/security/pkcs11/MessageDigest/TestCloning.java 0000000 generic-all
-sun/security/pkcs11/Signature/SignatureTestPSS.java 0000000 generic-all
-
-# https://bugs.openjdk.org/browse/JDK-8312488
-tools/jpackage/share/AppLauncherEnvTest.java 0000000 generic-all
-
-# java.lang.Exception: Proc abnormal end
-sun/security/krb5/auto/Cleaners.java 0000000 generic-all
-
-# result: Failed. Execution failed: `main' threw exception: java.io.IOException: Mount point not found
-# https://bugs.openjdk.org/browse/JDK-8166162
-
-java/io/File/createTempFile/TargetDirectory.java 8166162 generic-all
-java/nio/file/Files/CheckPermissions.java 8166162 generic-all
-java/nio/file/Files/TemporaryFiles.java 8166162 generic-all
-java/nio/file/Files/Misc.java 8166162 generic-all
-java/nio/file/Files/CopyAndMove.java 8166162 generic-all
-java/nio/file/Files/InterruptCopy.java 8166162 generic-all
-java/nio/file/Files/FileAttributes.java 8166162 generic-all
-java/nio/file/attribute/BasicFileAttributeView/SetTimesNanos.java 8166162 generic-all
-java/nio/file/attribute/AclFileAttributeView/Basic.java 8166162 generic-all
-java/nio/file/attribute/DosFileAttributeView/Basic.java 8166162 generic-all
-java/nio/file/attribute/PosixFileAttributeView/Basic.java 8166162 generic-all
-java/nio/file/attribute/UserDefinedFileAttributeView/Basic.java 8166162 generic-all
-java/nio/file/FileStore/Basic.java 8166162 generic-all
-java/nio/channels/FileChannel/directio/DirectIOTest.java 8166162 generic-all
-java/nio/channels/FileChannel/directio/ReadDirect.java 8166162 generic-all
-java/nio/channels/FileChannel/directio/PreadDirect.java 8166162 generic-all
-java/nio/channels/FileChannel/directio/PwriteDirect.java 8166162 generic-all
-java/nio/channels/FileChannel/directio/WriteDirect.java 8166162 generic-all
-
-# utf-8 locale is missing on build machine
-# https://bugs.openjdk.org/browse/JDK-8249079
-
-java/lang/invoke/lambda/LambdaFileEncodingSerialization.java 8249079 generic-all
-
-# disable scoped value (incubating feature) test pending investigation
-
-jdk/incubator/concurrent/ScopedValue/StressStackOverflow.java 000000 generic-all
-java/lang/ScopedValue/StressStackOverflow.java 000000 generic-all
-
-# https://bugs.openjdk.org/browse/JDK-8309214
-sun/security/pkcs11/KeyStore/CertChainRemoval.java 000000 generic-all
-
diff -pruN 22.0.2+9-1/debian/tests/problems-s390x.txt 22.0.2+9-1ubuntu1/debian/tests/problems-s390x.txt
--- 22.0.2+9-1/debian/tests/problems-s390x.txt	2023-10-20 08:16:38.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/problems-s390x.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,7 +0,0 @@
-# https://bugs.openjdk.org/browse/JDK-8309698
-runtime/NMT/VirtualAllocCommitMerge.java 000000 generic-all
-
-# LingeredApp error
-# java.lang.NoClassDefFoundError: jdk/test/lib/Utils
-serviceability/attach/AttachNegativePidTest.java 000000 generic-all
-
diff -pruN 22.0.2+9-1/debian/tests/problems.csv 22.0.2+9-1ubuntu1/debian/tests/problems.csv
--- 22.0.2+9-1/debian/tests/problems.csv	1970-01-01 00:00:00.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/problems.csv	2024-07-18 02:41:05.000000000 +0000
@@ -0,0 +1,68 @@
+Test,Bug,Comment,Packages,Arch,Release
+Error:  runtime/Unsafe/InternalErrorTest.java,JDK-8335238,"To investigate, not critical for security release – JDK-22 will expire before OO release",:openjdk-22,i386,:release-all
+Error:  serviceability/jvmti/vthread/SuspendResume1/SuspendResume1.java#default,,"Deadlock, new failure, not critical – JDK-22 will expire before OO release",:openjdk-22,ppc64el,:release-all
+FAILED: compiler/arguments/CheckCICompilerCount.java,,"Existing failure (exit code 0, expected 1)",:openjdk-17:openjdk-21:openjdk-22,i386,:release-all
+FAILED: compiler/codecache/MHIntrinsicAllocFailureTest.java,JDK-8298947,The issue only happens on armhf platform. ,:openjdk-17:openjdk-21,armhf,:release-all
+FAILED: gtest/GTestWrapper.java,,"17:UninitializedDoubleElementWorkerDataArrayTest.print_summary_on_test_vm, ",:openjdk-17:openjdk-21,i386,:release-all
+FAILED: java/foreign/critical/TestCritical.java,,"SEGSEGV in test, submit bug, not critical for security release",:openjdk-22,s390x,:release-all
+FAILED: java/foreign/StdLibTest.java,,Ignore test failure in the preview api,:openjdk-21,:i386,:release-all
+FAILED: java/foreign/TestAddressDereference.java,,Ignore test failure in the preview api,:openjdk-21,:i386,:release-all
+FAILED: java/foreign/TestIllegalLink.java,,Ignore test failure in the preview api,:openjdk-21,:i386,:release-all
+FAILED: java/foreign/TestLinker.java,,Ignore test failure in the preview api,:openjdk-21,:i386,:release-all
+FAILED: java/foreign/TestSegments.java,,Ignore test failure in the preview api,:openjdk-21,:i386,:release-all
+FAILED: java/foreign/TestUpcallHighArity.java,,Ignore test failure in the preview api,:openjdk-21,:i386,:release-all
+FAILED: java/foreign/TestUpcallStructScope.java,,Ignore test failure in the preview api,:openjdk-21,:i386,:release-all
+FAILED: java/io/File/createTempFile/TargetDirectory.java,JDK-8166162,Container issue,:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/io/File/GetXSpace.java,,"Container issue, disk space size exceeds 32 bit integer",:openjdk-17:openjdk-21:openjdk-22,i386,:release-all
+FAILED: java/nio/channels/FileChannel/directio/DirectIOTest.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/channels/FileChannel/directio/PreadDirect.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/channels/FileChannel/directio/PwriteDirect.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/channels/FileChannel/directio/ReadDirect.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/channels/FileChannel/directio/WriteDirect.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/attribute/AclFileAttributeView/Basic.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/attribute/BasicFileAttributeView/CreationTime.java,JDK-8166162,Container issue,:openjdk-22,i386,:release-all
+FAILED: java/nio/file/attribute/BasicFileAttributeView/SetTimesNanos.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/attribute/DosFileAttributeView/Basic.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/attribute/PosixFileAttributeView/Basic.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/attribute/UserDefinedFileAttributeView/Basic.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/Files/CheckPermissions.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/Files/CopyAndMove.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/Files/CopyMoveVariations.java,JDK-8166162,Container issue,:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/Files/FileAttributes.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/Files/InterruptCopy.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/Files/Misc.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/Files/TemporaryFiles.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: java/nio/file/FileStore/Basic.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11::openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: runtime/cds/appcds/jcmd/JCmdTestDynamicDump.java,,flaky test (?) existing comment,:openjdk-17,i386:arm64:amd64,:release-all
+FAILED: runtime/cds/appcds/jcmd/JCmdTestFileSafety.java,,flaky test (?) existing comment,:openjdk-17,i386:arm64:amd64:ppc64el,:release-all
+FAILED: runtime/cds/appcds/jcmd/JCmdTestStaticDump.java,,flaky test (?) existing comment,:openjdk-17,ppc64el,:release-all
+FAILED: runtime/ErrorHandling/MachCodeFramesInErrorFile.java,,java.lang.InternalError: a fault occurred in a recent unsafe memory access operation in compiled Java code at java.base/java.lang.Long.toHexString(Long.java:309) at,:openjdk-17:openjdk-21,armhf,:release-all
+FAILED: runtime/jni/nativeStack/TestNativeStack.java,JDK-8312016,"Backport fix (do not add patch, the fix just disables the test)",:openjdk-lts:openjdk-11:openjdk-17,armhf,:release-all
+FAILED: runtime/LoadClass/LongBCP.java,JDK-8166162,Container issue,:openjdk-lts:openjdk-11:openjdk-17:openjdk-21:openjdk-22,:arch-all,:release-all
+FAILED: runtime/Monitor/ConcurrentDeflation.java,,LockingMode == 0 (LM_MONITOR) is not fully implemented on this architectureError: Could not create the Java Virtual Machine.,:openjdk-21,armhf,:release-all
+FAILED: runtime/NMT/VirtualAllocCommitMerge.java,JDK-8309698,P4 bug (existing issue),:openjdk-21:openjdk-22,s390x,:release-all
+FAILED: serviceability/AsyncGetCallTrace/MyPackage/ASGCTBaseTest.java,JDK-8303168,Existing bug,:openjdk-21,armhf,:release-all
+FAILED: tools/jlink/JLinkTest.java,JDK-8240349,Bugfix failed for i386 (P4 bug),:openjdk-17:openjdk-21:openjdk-22,i386,:release-all
+FAILED: jdk/javadoc/doclet/dupThrowsTags/TestDupThrowsTags.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/T6735320/T6735320.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testBadHtml/TestBadHtml.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testBadPackageFileInJar/TestBadPackageFileInJar.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testHtmlTableStyles/TestHtmlTableStyles.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testLinkOption/TestLinkOption.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testNonInlineHtmlTagRemoval/TestNonInlineHtmlTagRemoval.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testPackageHtml/TestPackageHtml.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testParamTaglet/TestParamTaglet.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testRelativeLinks/TestRelativeLinks.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testSeeTag/TestSeeTag.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testStylesheet/TestStylesheet.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testSummaryTag/TestSummaryTag.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testSupplementary/TestSupplementary.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testValueTag/TestValueTag.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/doclet/testWarnings/TestWarnings.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/tool/doclint/DocLintTest.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: jdk/javadoc/tool/modules/Modules.java,,tests failing due to disable-doclint-by-default.diff (reproducible build maintainer patch),:openjdk-lts:openjdk-11,:arch-all,:release-all
+FAILED: sun/security/ec/TestEC.java,,"New failure in CI, passes locally",:openjdk-lts:openjdk-11,:amd64,:release-all
+FAILED: runtime/NMT/SafepointPollingPages.java,,ThreadLocalHandshakes not yet supported on this platform. Disable test,:openjdk-lts:openjdk-11,:armhf,:release-all
+FAILED: serviceability/attach/ConcAttachTest.java,,java.lang.RuntimeException: Process is still alive. Can't get its output.,:openjdk-lts:openjdk-11,:armhf,:release-all
+FAILED: serviceability/attach/RemovingUnixDomainSocketTest.java,,java.lang.RuntimeException: Process is still alive. Can't get its output.,:openjdk-lts:openjdk-11,:armhf,:release-all
+FAILED: runtime/cds/appcds/jcmd/JCmdTestStaticDump.java,,Lingered App not found (CI),:openjdk-17,:amd64,:release-all
diff -pruN 22.0.2+9-1/debian/tests/write-problems 22.0.2+9-1ubuntu1/debian/tests/write-problems
--- 22.0.2+9-1/debian/tests/write-problems	2023-10-20 08:16:38.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/write-problems	1970-01-01 00:00:00.000000000 +0000
@@ -1,25 +0,0 @@
-#!/bin/bash
-
-problem_list=$1
-upstream_problems=$2
-suite=$3
-
-cat ${upstream_problems} > ${problem_list}
-
-if [[ -f debian/tests/problems-${suite}.txt ]]; then
-	cat debian/tests/problems-${suite}.txt >> ${problem_list}
-fi
-
-distrel=`lsb_release --codename --short`
-if [[ -f debian/tests/problems-${distrel}.txt ]]; then
-	cat debian/tests/problems-${distrel}.txt >> ${problem_list}
-fi
-
-host_arch="${DEB_HOST_ARCH:-$(dpkg --print-architecture)}"
-if [[ -f debian/tests/problems-${host_arch}.txt ]]; then
-	cat debian/tests/problems-${host_arch}.txt >> ${problem_list}
-fi
-
-if [[ -f debian/tests/problems-${distrel}-${host_arch}.txt ]]; then
-	cat debian/tests/problems-${distrel}-${host_arch}.txt >> ${problem_list}
-fi
diff -pruN 22.0.2+9-1/debian/tests/write-problems.in 22.0.2+9-1ubuntu1/debian/tests/write-problems.in
--- 22.0.2+9-1/debian/tests/write-problems.in	1970-01-01 00:00:00.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/write-problems.in	2024-07-18 02:41:05.000000000 +0000
@@ -0,0 +1,13 @@
+#!/bin/bash
+
+problem_list=$1
+upstream_problems=$2
+
+cat ${upstream_problems} > ${problem_list}
+distrel=`lsb_release --codename --short`
+host_arch="${DEB_HOST_ARCH:-$(dpkg --print-architecture)}"
+
+grep -e ${host_arch} -e "arch-all" debian/tests/problems.csv | \
+  grep -e ${distrel} -e "release-all" | \
+  grep -e "@basename@" | \
+  awk -F',|:' '{gsub(/ /, "", $2); print $2" 000000 generic-all" }' >> ${problem_list}
diff -pruN 22.0.2+9-1/debian/tests/write-problems.sh 22.0.2+9-1ubuntu1/debian/tests/write-problems.sh
--- 22.0.2+9-1/debian/tests/write-problems.sh	1970-01-01 00:00:00.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/tests/write-problems.sh	2024-07-18 02:41:05.000000000 +0000
@@ -0,0 +1,13 @@
+#!/bin/bash
+
+problem_list=$1
+upstream_problems=$2
+
+cat ${upstream_problems} > ${problem_list}
+distrel=`lsb_release --codename --short`
+host_arch="${DEB_HOST_ARCH:-$(dpkg --print-architecture)}"
+
+grep -e ${host_arch} -e "arch-all" debian/tests/problems.csv | \
+  grep -e ${distrel} -e "release-all" | \
+  grep -e "openjdk-22" | \
+  awk -F',|:' '{gsub(/ /, "", $2); print $2" 000000 generic-all" }' >> ${problem_list}
diff -pruN 22.0.2+9-1/debian/watch.in 22.0.2+9-1ubuntu1/debian/watch.in
--- 22.0.2+9-1/debian/watch.in	2024-01-05 08:19:55.000000000 +0000
+++ 22.0.2+9-1ubuntu1/debian/watch.in	2024-07-18 02:41:05.000000000 +0000
@@ -10,4 +10,4 @@ component=googletest,\
 repack,\
 compression=xz \
     @gtest_repo@ \
-    (?:.*?/)?v([\.\d]+)\.tar\.gz @gtest_tag@
+    (?:.*?/)?v(@gtest_tag@)\.tar\.gz @gtest_tag@
